<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013-2020 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2019.3/2027974
 */
namespace TestIntegration\Model;

/**
 * Interface ITestRun describing a test run
 * @package TestIntegration\Model
 */
interface ITestRun
{
    // Queue task for test run changes
    const TASK_TEST_RUN = 'task.testrun';

    /**
     * Get the change id
     * @return int
     */
    public function getChange() : int;

    /**
     * Set the change id
     * @param int $change
     * @return mixed
     */
    public function setChange(int $change);

    /**
     * Get the review version
     * @return mixed
     */
    public function getVersion();

    /**
     * Set the review version
     * @param int $version
     * @return mixed
     */
    public function setVersion(int $version);

    /**
     * Get the name of the test
     * @return string
     */
    public function getTest() : string;

    /**
     * Set the name of the test
     * @param string $test
     * @return mixed
     */
    public function setTest(string $test);

    /**
     * Get the status
     * @return mixed
     */
    public function getStatus();

    /**
     * Set the status
     * @param string $status
     * @return mixed
     */
    public function setStatus(string $status);

    /**
     * Get the url
     * @return string
     */
    public function getUrl();

    /**
     * Set the url
     * @param string $url
     * @return mixed
     */
    public function setUrl(string $url);

    /**
     * Get the messages
     * @return mixed
     */
    public function getMessages();

    /**
     * Set the messages
     * @param array $messages
     * @return mixed
     */
    public function setMessages(array $messages);

    /**
     * Get the start time
     * @return int
     */
    public function getStartTime() : int;

    /**
     * Set the start time
     * @param int $startTime
     * @return mixed
     */
    public function setStartTime(int $startTime);

    /**
     * Get the completed time
     * @return mixed
     */
    public function getCompletedTime();

    /**
     * Set the completed time
     * @param int|null $completedTime
     * @return mixed
     */
    public function setCompletedTime($completedTime);

    /**
     * Set the uuid
     * @param string|null $uuid
     * @return mixed
     */
    public function setUuid($uuid);


    /**
     * Get the uuid
     * @return mixed
     */
    public function getUuid();

    /**
     * Get the title
     * @return mixed
     */
    public function getTitle();

    /**
     * Set the title
     * @param mixed     $title    the title
     * @return mixed
     */
    public function setTitle($title);
}
